//+------------------------------------------------------------------+
//|                              
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 Brown 
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern int TimeFrame=0;
extern int MAPeriod=5;
extern int ma_shift=1;  //Cyan bottom Dn
extern int ma_method=3;    // 3 Linear weighted moving average
extern int applied_price=1;//1 Open price. 
extern int MAPeriod1=5;
extern int ma_shift1=3; //Red bottom up
extern int ma_method1=3;   // 3 Linear weighted moving average
extern int applied_price1=1; //1 Open price. 
extern int MAPeriod2=5;
extern int ma_shift2=7; //Red bottom up
extern int ma_method2=3;   // 3 Linear weighted moving average
extern int applied_price2=1; //1 Open price. 
extern int     maxBars  = 400;

extern bool   alertsOn          = false;
extern bool   alertsOnCurrent   = False;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = True;
extern bool   alertsEmail       = false;

extern bool   ShowValue        = true;
extern double  Valueloc        = 0.3;
extern string ValueIdentifier = "RK-tripleval";
extern color  txtUpColor     = SkyBlue; //Green;
extern color  txtDownColor   = Magenta; //Magenta; //Crimson; //Red;

extern bool   ShowArrows       = true;
extern string ArrowsIdentifier = "RK-TripleMA";
extern double arrowsDisplacement = 2.0;
extern color  ArrowUpColor     = DeepSkyBlue; //Green;
extern color  ArrowDownColor   = Red; //Crimson; //Red;
extern int    arrowCodeup       = 241;
extern int    arrowCodedn       = 242;
extern int    arrowsSize         = 1;

double trend[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];

datetime prevtime = 0;

int init()
  {
   string short_name;
   string short_name1;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,trend);
   SetIndexLabel(0,"Trp-SkyBlue-LWB1");
   SetIndexLabel(1,"Trp-Red-LWB2");     
   SetIndexLabel(2,"Trp-Brown-LWB3");
   SetIndexLabel(3,"Trp-trd("+MAPeriod+") - "+DoubleToStr(MAPeriod1,2)+")");

    switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName (short_name+MAPeriod+") "+TimeFrameStr);  
 

return(0);
}

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
  }

   if (ShowValue)
   {
      int compareLength1 = StringLen(ValueIdentifier);
      for (i=ObjectsTotal()-1; i>= 0; i--)
      {
         string no = ObjectName(i);
            if (StringSubstr(no,0,compareLength1) == ValueIdentifier)
                ObjectDelete(no);  
      }   
   }             
return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
             limit = MathMax(limit,-ma_shift);
             limit = MathMax(limit,-ma_shift1);
       if ( limit > maxBars )
   {
      limit = maxBars;
   }
   //
   //
   //
   //
   //
   
   for(int x=limit; x>=0; x--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[x]);
         if (y+ma_shift>=0)
               ExtMapBuffer1[x]=iMA(NULL,TimeFrame,MAPeriod ,ma_shift,ma_method, applied_price ,y)  ;//SkyBlue top up
         else  ExtMapBuffer1[x]=EMPTY_VALUE;
         if (y+ma_shift1>=0)
               ExtMapBuffer2[x]=iMA(NULL,TimeFrame,MAPeriod1,ma_shift1,ma_method1,applied_price1,y) ;//Green Middle
         else  ExtMapBuffer2[x]=EMPTY_VALUE;
         if (y+ma_shift1>=0)
               ExtMapBuffer3[x]=iMA(NULL,TimeFrame,MAPeriod2,ma_shift2,ma_method2,applied_price2,y) ;//Brown top Dwn
         else  ExtMapBuffer3[x]=EMPTY_VALUE;
         //
         //
         //
         //
         //
         
         trend[x] = trend[x+1];
         if (ExtMapBuffer1[x]!=EMPTY_VALUE && ExtMapBuffer2[x]!=EMPTY_VALUE && ExtMapBuffer3[x]!=EMPTY_VALUE)
         {
            double maxma = MathMax(ExtMapBuffer1[x],MathMax(ExtMapBuffer2[x],ExtMapBuffer3[x]));
            double minma = MathMin(ExtMapBuffer1[x],MathMin(ExtMapBuffer2[x],ExtMapBuffer3[x]));
            if (Close[x]<minma && Open[x]<minma) trend[x] = -1;
            if (Close[x]>maxma && Open[x]>maxma) trend[x] =  1;
                       
            // Set up exit
            //if (trend[x+2] == 1 && Close[1] < ExtMapBuffer1[x+1]) trend[x] = 2;
            //if (trend[x+2] ==-1 && Close[1] > ExtMapBuffer1[x+1]) trend[x] = -2;
         }         
         manageArrow(x);
         manageValue(x);
   }
   manageAlerts();  
   return(0);
  }
//+------------------------------------------------------------------+
   
 void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //if ((Close [whichBar]>= lower[whichBar]) && (Close[whichBar] <= upper[whichBar])) //{ prevtime = 0;
       
      if (ExtMapBuffer2[whichBar]>= ExtMapBuffer1[whichBar] && ExtMapBuffer2[whichBar] > Close[whichBar] && ExtMapBuffer1[whichBar] <= Open[whichBar] 
      && (prevtime != Time[0]))doAlert(whichBar,"up"  ,1);
      if (ExtMapBuffer1[whichBar]>= ExtMapBuffer2[whichBar] && ExtMapBuffer2[whichBar] < Close[whichBar] && ExtMapBuffer1[whichBar] >= Open[whichBar]
      && (prevtime != Time[0]))doAlert(whichBar,"down",-1);
 
   }
}
void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," tf-",(Period())," at ",
       TimeToStr(TimeLocal(),TIME_SECONDS)," RK-KC Alert "+"  Bid -"+DoubleToStr(Bid,Digits)+"  Ask -"+DoubleToStr(Ask,Digits)+"  "
       +DoubleToStr(value,2)+" KC Breakout-",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Keltner breakout "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
void manageArrow(int x)
{
   if (ShowArrows)
   {
      double dist = iATR(NULL,0,20,x)/1.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      if (trend[x] != trend[x+1])
         {
            string name = ArrowsIdentifier+Time[x];
            if (trend[x] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],Low[x]-arrowsDisplacement * dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,arrowCodeup);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
                  ObjectSet(name,OBJPROP_WIDTH,arrowsSize);
            
            }
            else
            if (trend[x] == -1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],High[x]+arrowsDisplacement * dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,arrowCodedn);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
                  ObjectSet(name,OBJPROP_WIDTH,arrowsSize);
            }
         }
   }
}


void manageValue(int x)
{
   if (ShowValue)
   {
      double dist = iATR(NULL,0,20,x)/Valueloc;
      string on = ValueIdentifier+":"+Time[x];
      ObjectDelete(on);         
                
      if (trend[x] != trend[x+1])
         {
            if (trend[x] == 1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[x], Low[x] - dist);
              ObjectSetText(on, DoubleToStr(Close[x], Digits) + " " 
              + TimeToStr(Time[x], TIME_MINUTES), 8, "Arial", txtUpColor);
            }
            else
            if (trend[x] == -1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[x], High[x] + dist);
              ObjectSetText(on, DoubleToStr(Close[x], Digits) + " " 
              + TimeToStr(Time[x], TIME_MINUTES), 8, "Arial", txtDownColor);
            }
         }
   }
}